
clear all;
fclose all;

source = 'C:\THESIS\DATA\EPIC\data\sondes\epic_leg2_sondes.txt';

fid = fopen([source],'r');

start_record_header = fgetl(fid);

fid = fopen([source],'r');

ind = 0;
num_record = 0;


while ~feof(fid)
  look = fgetl(fid);
  ind = ind+1;
  if strcmp(start_record_header,look)==1
    
    %%%% count number of records %%%%
    
    num_record = num_record+1;
    header_start(num_record) = ind;
  else
  end
end


%%%% Reset number of records %%%%%%

num_record = 0;


fid = fopen([source],'r');

while ~feof(fid)
  look = fgetl(fid);
  ind = ind+1;
  if strcmp(start_record_header,look)==1   
    
    %%%% count number of records %%%%
    
    num_record = num_record+1;
  
    
    %%%%% read header info, lat, lon and time %%%%%%%%
    dummy = fgetl(fid);
    dummy = fgetl(fid);
    data = fgets(fid); %%%% Grab location during sounding  %%%%%
    k=find(isspace(data)==1);
    lon_deg(num_record) = str2num(data(36:38));
    lon_min(num_record) = str2num(data(40:44));
    lat_deg(num_record) = str2num(data(49:50));
    lat_min(num_record) = str2num(data(52:56));
    data = fgets(fid); %%%% Grab time during sounding  %%%%%
    year(num_record)    = str2num(data(36:39));
    month(num_record)   = str2num(data(42:43));
    day(num_record)     = str2num(data(46:47));
    hour(num_record)    = str2num(data(50:51));
    mmm(num_record)     = str2num(data(53:54));
    sec(num_record)     = str2num(data(56:57));
    %%%% Read the rest of the header %%%%%%%%%%%%%%%%%%%%%%%%
    for i=1:10;
      dummy = fgetl(fid);
    end
    %%%% Done with the header %%%%%%%%%%%%%%%%%%%%%%
    %%%% Start reading the record %%%%%%%%%%%%%%%%%%
    for i = 1:header_start(num_record+1)-(header_start(num_record)+15);
      time(i,num_record)=fscanf(fid,'%f',1);
      press(i,num_record)=fscanf(fid,'%f',1);
      t(i,num_record)=fscanf(fid,'%f',1);
      td(i,num_record)=fscanf(fid,'%f',1);
      rh(i,num_record)=fscanf(fid,'%f',1);
      U(i,num_record)=fscanf(fid,'%f',1);
      V(i,num_record)=fscanf(fid,'%f',1);
      wspd(i,num_record)=fscanf(fid,'%f',1);
      wdir(i,num_record)=fscanf(fid,'%f',1); 
      dummy = fscanf(fid,'%f',5);
      h(i,num_record) = fscanf(fid,'%f',1);
      dummy = fgetl(fid);
    end
    
    else
    
    end
end



%%%% **********************************************************************************
%%%% Note that code will break here, but this is OK (should be continued manually) %%%%



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Problematic sondes/values %%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%% Eliminate data above 20 km %%%%

h(2001:2547,:)     = [];
time(2001:2547,:)  = [];
press(2001:2547,:) = [];
t(2001:2547,:)     = [];
td(2001:2547,:)    = [];
rh(2001:2547,:)    = [];
U(2001:2547,:)     = [];
V(2001:2547,:)     = [];
wspd(2001:2547,:)  = [];
wdir(2001:2547,:)  = [];


%%%% Sonde #14 has bad values for T, Td, RH (95:169) %%%%

t(95:169,14)   = nan;
td(95:169,14)  = nan;
rh(95:169,14)  = nan;

%%%% Sondes # 16, 25, 28, 52, 58, 72, 96, 100, 102, 103 had "999.0000" for
%%%% entire Wind speed/direction profiles

m = find(wspd==999);
wspd(m) = nan; clear m;

m = find(wdir==999);
wdir(m) = nan; clear m;

m = find(U==9999);
U(m) = nan; clear m;

m = find(V==9999);
V(m) = nan; clear m;

%%%% Sondes # 4 (2560m), 14 (2640m), 15 (2050m), 81 (1780m) didn't go above the specified level and the directly-measured 
%%%% parameters have 0s there   - the following solves problems for the 3-km graphs, for higher plots data should be checked over again 

press(256:2000,4)= nan;
t(256:2000,4)    = nan;
td(256:2000,4)   = nan;
rh(256:2000,4)   = nan;
U(256:2000,4)    = nan;
V(256:2000,4)    = nan;
wspd(256:2000,4) = nan;
wdir(256:2000,4) = nan;

press(264:2000,14)= nan;
t(264:2000,14)    = nan;
td(264:2000,14)   = nan;
rh(264:2000,14)   = nan;
U(264:2000,14)    = nan;
V(264:2000,14)    = nan;
wspd(264:2000,14) = nan;
wdir(264:2000,14) = nan;

press(205:2000,15)= nan;
t(205:2000,15)    = nan;
td(205:2000,15)   = nan;
rh(205:2000,15)   = nan;
U(205:2000,15)    = nan;
V(205:2000,15)    = nan;
wspd(205:2000,15) = nan;
wdir(205:2000,15) = nan;

press(178:2000,81)= nan;
t(178:2000,81)    = nan;
td(178:2000,81)   = nan;
rh(178:2000,81)   = nan;
U(178:2000,81)    = nan;
V(178:2000,81)    = nan;
wspd(178:2000,81) = nan;
wdir(178:2000,81) = nan;

%%%% Post-processing in order to create a permanent .mat file, suitable for the 
%%%% code sondes_graphs.m - Basically putting NaN values in missing sondes

mday(1:107)=day(1:107)+(hour(1:107)/24);
mday(108)=23.9167;
mday(109:117)=day(108:116)+(hour(108:116)/24);

clear day hour mmm sec month year
clear data dummy fid header_start i ind k look num* source start*

lat(1:107)=lat_deg(1:107)+lat_min(1:107)/60;
lat(108)=nan;
lat(109:117)=lat_deg(108:116)+lat_min(108:116)/60;
clear lat_*

lon(1:107)=lon_deg(1:107)+lon_min(1:107)/60;
lon(108)=nan;
lon(109:117)=lon_deg(108:116)+lon_min(108:116)/60;
clear lon_*

U_int(:,1:107)=U(:,1:107);
U_int(:,108)=nan;
U_int(:,109:117)=U(:,108:116);
clear U

V_int(:,1:107)=V(:,1:107);
V_int(:,108)=nan;
V_int(:,109:117)=V(:,108:116);
clear V

h_all(:,1:107)=h(:,1:107);
h_all(:,108)=nan;
h_all(:,109:117)=h(:,108:116);
clear h

h_int=10:10:20000;

press_int(:,1:107)=press(:,1:107);
press_int(:,108)=nan;
press_int(:,109:117)=press(:,108:116);
clear press

rh_int(:,1:107)=rh(:,1:107);
rh_int(:,108)=nan;
rh_int(:,109:117)=rh(:,108:116);
clear rh

t_int(:,1:107)=t(:,1:107);
t_int(:,108)=nan;
t_int(:,109:117)=t(:,108:116);
clear t

td_int(:,1:107)=td(:,1:107);
td_int(:,108)=nan;
td_int(:,109:117)=td(:,108:116);
clear td

time_all(:,1:107)=time(:,1:107);
time_all(:,108)=nan;
time_all(:,109:117)=time(:,108:116);
clear time

dir_int(:,1:107)=wdir(:,1:107);
dir_int(:,108)=nan;
dir_int(:,109:117)=wdir(:,108:116);
clear wdir

spd_int(:,1:107)=wspd(:,1:107);
spd_int(:,108)=nan;
spd_int(:,109:117)=wspd(:,108:116);
clear wspd

clear ans


save C:\THESIS\Processing_Results\EPIC2001\sondes\epic_sondes_reader

%save /home/disk/akropolis_users2/pavlos/proj/EPIC/data/soundings.stratus/epic_stratus_sounding time press t td rh U V wspd wdir h year month day hour mmm sec lat_deg lat_min lon_deg lon_min;
