%%%% pacs 2003 soundings reader %%%
%%%% PTU and WND files 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all;
fclose all;

pathdata = 'C:\THESIS\DATA\PACS03\DATA\sondes\';
outpath  = 'C:\THESIS\Processing_Results\Stratus03\sondes\';
eval(['cd ', pathdata]);

aa = dir('*.PTU');

k = length(aa);
[num] = num2str(k);
disp('Number of rawinsonde *.ptu files : '); disp([num]); 

%%%%%%%%%% starting file %%%%%%%%%%%%%%%%%%%%%%%%
st =1;
%%%%%%%%%%%%%%%%%% last file == k %%%%%%%%%%%%%%%

for w = st:k;
w
[numf] = num2str(w);

disp('# of *.ptu file in process :'); disp ( [numf]); 

%%%%%%% k is the # of *.cdf files need to be processed. %%%%%%%%

ptu_filename = [aa(w).name]
wnd_filename = [ptu_filename(1:8) '.wnd'];

%%%%%%%%%%%%%%%%%% INPUT DATA FILE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%base_julian   = get_julian_day(2002,12,31);
%offset_julian = base_julian+str2num(ceil_filename(6:8));
%[gtime] = get_calendar_date(offset_julian);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% READ THE PTU FILE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

year(w) = 2000 + str2num(ptu_filename(1:2));
month(w) = str2num(ptu_filename(3:4));
day (w)  = str2num(ptu_filename(5:6));
hour(w)  = str2num(ptu_filename(7:8));

fid1=fopen(ptu_filename,'r');

if fid1 == -1
error(['Cannot read ' ceil_filename]);
end

%%% read overhead...
dummy=fgetl(fid1);dummy=fgetl(fid1);dummy=fgetl(fid1);dummy=fgetl(fid1);dummy=fgetl(fid1);
dummy=fscanf(fid1,'%s',5);

hh_mm=fscanf(fid1,'%s',1); f = findstr(hh_mm,':');   %%%% Read hour/minutes from the Sounding system clock   ****** BE CAREFUL: first 6 sondes had bad clock ????
hour2(w)=str2num(hh_mm(1:f-1));
min(w)=str2num(hh_mm(f+1:length(hh_mm)));

dummy=fgetl(fid1);dummy=fgetl(fid1);dummy=fgetl(fid1);
dummy=fscanf(fid1,'%s',2);
dummy = fscanf(fid1,'%f',1);
lat_deg(w) = floor(dummy);
lat_min(w) = dummy-lat_deg(w);  %% fraction in degrees
dummy=fscanf(fid1,'%s',1);
dummy = fscanf(fid1,'%f',1);
lon_deg(w) = floor(dummy);
lon_min(w) = dummy-lon_deg(w);
dummy=fgetl(fid1);dummy=fgetl(fid1);
dummy=fgetl(fid1);dummy=fgetl(fid1);dummy=fgetl(fid1);dummy=fgetl(fid1);dummy=fgetl(fid1);
dummy=fgetl(fid1);dummy=fgetl(fid1);dummy=fgetl(fid1);dummy=fgetl(fid1);dummy=fgetl(fid1);
dummy=fgetl(fid1);dummy=fgetl(fid1);dummy=fgetl(fid1);dummy=fgetl(fid1);dummy=fgetl(fid1);
dummy=fgetl(fid1);dummy=fgetl(fid1);dummy=fgetl(fid1);dummy=fgetl(fid1);dummy=fgetl(fid1);
dummy=fgetl(fid1);dummy=fgetl(fid1);dummy=fgetl(fid1);dummy=fgetl(fid1);dummy=fgetl(fid1);
i=0;
while ~feof(fid1)
    temp=fgetl(fid1); num=findstr(temp,'/'); temp(num)='9';   %%%% Put "9" in place of "/" and disregard them later in the QC (<10000) 
    i=i+1;    
       [data]=sscanf(temp,'%d %d %f %f %f %f') ;
       press(i,w) = data(3);
       h(i,w)     = data(4);
       t(i,w)     = data(5);
       rh(i,w)    = data(6);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% READ THE WND FILE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


fid2=fopen(wnd_filename,'r');

if fid2 == -1
error(['Cannot read ' ceil_filename]);
end

%%% read overhead...
dummy=fgetl(fid2);dummy=fgetl(fid2);dummy=fgetl(fid2);dummy=fgetl(fid2);dummy=fgetl(fid2);

dummy=fscanf(fid2,'%s',5);
hh_mm=fscanf(fid2,'%s',1);
%f = findstr(hh_mm,':');
%hor(w)=str2num(hh_mm(1:f-1));
%mmm(w)=str2num(hh_mm(f+1:length(hh_mm)));
dummy=fgetl(fid2);dummy=fgetl(fid2);dummy=fgetl(fid2);
dummy=fscanf(fid2,'%s',2);
dummy = fscanf(fid2,'%f',1);
lat_deg(w) = floor(dummy);
lat_min(w) = dummy-lat_deg(w);
dummy=fscanf(fid2,'%s',1);
dummy = fscanf(fid2,'%f',1);
lon_deg(w) = floor(dummy);
lon_min(w) = dummy-lon_deg(w);
dummy=fgetl(fid2);dummy=fgetl(fid2);
dummy=fgetl(fid2);dummy=fgetl(fid2);dummy=fgetl(fid2);dummy=fgetl(fid2);dummy=fgetl(fid2);
dummy=fgetl(fid2);dummy=fgetl(fid2);dummy=fgetl(fid2);dummy=fgetl(fid2);dummy=fgetl(fid2);
dummy=fgetl(fid2);dummy=fgetl(fid2);dummy=fgetl(fid2);dummy=fgetl(fid2);dummy=fgetl(fid2);
dummy=fgetl(fid2);dummy=fgetl(fid2);dummy=fgetl(fid2);dummy=fgetl(fid2);dummy=fgetl(fid2);
dummy=fgetl(fid2);dummy=fgetl(fid2);dummy=fgetl(fid2);dummy=fgetl(fid2);dummy=fgetl(fid2);
i=0;
while ~feof(fid2)
    temp=fgetl(fid2); num=findstr(temp,'/'); temp(num)='9';
    i=i+1;    
       [data]=sscanf(temp,'%d %d %f %f %f %f %f');
       %press(i,w) = data(3);
       %h(i,w)     = data(4);
       spd(i,w)   = data(6);
       dir(i,w)   = data(7);
end

end



%%%%% Interpolate the sounding....from surface to 20 km %%%%%%%%%%%%%%%%%%%

%%% FIRST QUALITY CONTROL....


h_int = [10:10:20000];

for i=1:w;
    g=find(h(:,i)>0 & h(:,i)<20000);

    if i==8    %%%% Sondes #8 and #14 needed more repetitions for diff(h)>0 
        num_rep=20;
    else if i==14
        num_rep=60;
        else
        num_rep=6;
        end
    end
    
    for m=1:num_rep;    
        gk=find(diff(h(g,i))>0);
        c = g(gk); clear g; g=c; clear c gk;
    end    
    
    gg = find(t(g,i)>-273 & t(g,i)<10000);
    if isempty(gg)==0
        t_int1(1:length(h_int),i)     =  interp1(h(g(gg),i),t(g(gg),i),h_int)'; clear gg;
    end
    
    gg = find(rh(g,i)>0 & rh(g,i)<200);
    if isempty(gg)==0
        rh_int1(1:length(h_int),i)    =  interp1(h(g(gg),i),rh(g(gg),i),h_int)'; clear gg;
    end
    
    gg = find(press(g,i)>0 & press(g,i)<10000);
    if isempty(gg)==0
        press_int1(1:length(h_int),i) =  interp1(h(g(gg),i),press(g(gg),i),h_int)'; clear gg;
    end
    
    gg = find(spd(g,i)>0 & spd(g,i)<10000);
    if isempty(gg)==0
        spd_int1(1:length(h_int),i) =  interp1(h(g(gg),i),spd(g(gg),i),h_int)'; clear gg;
    end
    
    gg = find(dir(g,i)>0 & dir(g,i)<500);
    if isempty(gg)==0
        dir_int1(1:length(h_int),i) =  interp1(h(g(gg),i),dir(g(gg),i),h_int)'; clear gg;
    end
    clear g;
end

%%%%%%% Post-processing in order to create a permanent .mat file, suitable for the 
%%%%%%% code sondes_graphs.m - Basically putting NaN values for missing sonde - Also NaN for t and rh for sonde #33

dir_int1(:,21)=nan;   %%%% #21 (03/11/21,18:00) was problematic; no values for wind speed/direction
spd_int1(:,21)=nan;


%hour(3)=5;    %%%%%%% Correction of Hour and Minutes for the first 6 sondes with questionable timing
%hour(6)=23;
min(1:6)=0;
mday(1:33)=day(1:33)+(hour(1:33)/24)+(min(1:33)/1440);
mday(34)=22.0000;
mday(35:44)=day(34:43)+(hour(34:43)/24)+(min(34:43)/1440);

clear day hour* min month year t press rh spd dir
clear aa data dummy f fid1 fid2 hh_mm hor i k m num* outpath pathdata ptu* st temp w*

lat(1:33)=lat_deg(1:33)+lat_min(1:33);
lat(34)=nan;
lat(35:44)=lat_deg(34:43)+lat_min(34:43);
clear lat_*

lon(1:33)=lon_deg(1:33)+lon_min(1:33);
lon(34)=nan;
lon(35:44)=lon_deg(34:43)+lon_min(34:43);
clear lon_*

h_all(:,1:33)=h(:,1:33);
h_all(:,34)=nan;
h_all(:,35:44)=h(:,34:43);
clear h

%h_int=10:10:20000;

press_int(:,1:33)=press_int1(:,1:33);
press_int(:,34)=nan;
press_int(:,35:44)=press_int1(:,34:43);
clear press_int1

rh_int(:,1:32)=rh_int1(:,1:32);
rh_int(:,33:34)=nan;
rh_int(:,35:44)=rh_int1(:,34:43);
clear rh_int1

t_int(:,1:32)=t_int1(:,1:32);
t_int(:,33:34)=nan;
t_int(:,35:44)=t_int1(:,34:43);
clear t_int1

dir_int(:,1:33)=dir_int1(:,1:33);
dir_int(:,34)=nan;
dir_int(:,35:44)=dir_int1(:,34:43);
clear dir_int1

spd_int(:,1:33)=spd_int1(:,1:33);
spd_int(:,34)=nan;
spd_int(:,35:44)=spd_int1(:,34:43);
clear spd_int1

clear ans

save C:\THESIS\Processing_Results\Stratus03\sondes\stratus03_sondes_reader 



%{
%%%%% FAIRALL REQUEST TO COMPARE THE INVERSION BASE ESTIMATES FROM THE SOUNDINGS
%%%%% WITH THE CLOUD TOP FROM THE MMCR 



load f:\PACS2003\data\mmcr\mmcr_pacs_2003
jul_day_mmcr=time;
for i = 1:length(k);
  f=find(abs(jul_day_mmcr-jul_day_sonde(k(i)))==min(abs(jul_day_mmcr-jul_day_sonde(k(i)))));
  cloud_radar_top_during_sounding(i)=cloud_top(f);
end


%%% Inversion strength from the soundings... %%%%

for i = 1:length(k);
    id_base(i) = inv_base_height(k(i))/10;
    inv_base_mu(i) = mu(id_base(i),k(i));
    id_top(i)  = inv_top_height(k(i))/10;
    inv_top_mu(i) = mu(id_top(i),k(i));
    id_max(i)  = find(mu(:,k(i))==max(mu(:,k(i))));
    inv_max_mu(i) = mu(id_max(i),k(i));
end

    

figure(1)
set(gcf,'DefaultAxesFonts',14);
h=plot(jul_day_sonde(k),inv_base_height(k),'k');
set(h,'linewidth',2);
hold on
h=plot(jul_day_sonde(k),inv_top_height(k),'k');
set(h,'linewidth',2);
h=plot(jul_day_sonde(k),cloud_radar_top_during_sounding,'ro');
set(h,'linewidth',2);
%set(gca,'xtick',[283 288 293 298]);
%set(gca,'xticklabel',['10/10 | 10/15 | 10/20 | 10/25']);
xlabel('Day','FontName','times','FontSize',14);
ylabel('Height (m)','FontName','times','FontSize',14);
print -depsc2 F:\PACS2003\data\images\radar_sound_top.eps

figure(1)
orient tall
subplot(2,1,1)
set(gcf,'DefaultAxesFonts',14);
hist(inv_top_height(k)-inv_base_height(k),[30:30:300]);
xlabel('Inversion Thickness (m)','FontName','times','FontSize',14);
ylabel('# Occurance','FontName','times','FontSize',14);
subplot(2,1,2)
hist(cloud_radar_top_during_sounding-inv_base_height(k),[-100:30:300]);
xlabel('MMCR_{top}-Inversion Base (m)','FontName','times','FontSize',14);
ylabel('# Occurance','FontName','times','FontSize',14);
xlim([-100 300]);
print -djpeg90 F:\EPIC\data\EPIC/data/results.graphs/invesion_hist.jpg

%%%% load ceilometer data....

load f:\PACS2003\data\ceiloraw\results\final\weller03_ceilo_10min_a.txt


figure(4)
set(gcf,'DefaultAxesFonts',16);
imagesc(jul_day_sonde,[(1:401)-1]*10,real(theta(1:401,:)));
axis xy; colorbar;
hold on
plot(weller03_ceilo_10min_a(:,1),weller03_ceilo_10min_a(:,11),'k.');
plot(jul_day_mmcr,cloud_top,'g.');
plot(j_day,cld_base_median,'r.');
set(gca,'xtick',[283 288 293 298]);
set(gca,'xticklabel',['10/10 | 10/15 | 10/20 | 1025']);
xlabel('Day','FontName','times','FontSize',16);
ylabel('Height (m)','FontName','times','FontSize',16);
title('EPIC 2001, \theta, Ceilometer base (red), MMCR Top (black)','FontName','times','FontSize',16);
print -depsc2 F:\EPIC\data\EPIC/data/results.graphs/theta.eps


figure(5)
set(gcf,'DefaultAxesFonts',16);
imagesc(jul_day_sonde,[(1:401)-1]*10,r(1:401,:));
axis xy; colorbar;
hold on
plot(j_day,mmcr_top_comp_ceilo*1000-45,'k.');
plot(j_day,cld_base_median,'r.');
set(gca,'xtick',[283 288 293 298]);
set(gca,'xticklabel',['10/10 | 10/15 | 10/20 | 1025']);
xlabel('Day','FontName','times','FontSize',16);
ylabel('Height (m)','FontName','times','FontSize',16);
title('EPIC 2001, r (g/Kg), Ceilometer base (red), MMCR Top (black)','FontName','times','FontSize',16);
print -depsc2 F:\EPIC\data\EPIC/data/results.graphs/r.eps
%}